
function [sol,a,b]=biparticion(f,a1,b1,eps,n)
% solucin ecuaciones no lineales mediante biparticin 
%****************************************************************************
%*  [x,y]=biparticion(f,a1,b1,eps,n)                                        *
%*  f = Funcin que deseamos analizar ofrecida entre comillas simples.      *
%*      Esta funcin debe tener una nica variable.(ejem. 'x.^2+x+1').      *
%*  a1,b1 = Valores que definen el intervalo de estudio de la funcin.      *
%*  eps = Error permitido en el clculo del mnimo de la funcin.           *
%*  n = nmero mximo de iteraciones permitido.                             *
%*  x = punto en el que se encuentra el mnimo de la funcin.               *
%*  y = valor de la funcin en x.                                           *
%****************************************************************************

a(1)=a1;
b(1)=b1;
   
%Paso 1
Lk=b1-a1;
fa=f(a1);
fb=f(b1);
k=1;
if fa==0
        sol=a(k);
        return;
    end
    if fb==0
        sol=b(k);
        return;
    end


while Lk>eps
%Paso 2
    Xm = (a(k)+b(k))/2.0;
    fm=f(Xm);  

    if fm==0.0
        sol=Xm;
        return;
    end
    
    if fa*fm<0 
        b(k+1)= Xm;
        a(k+1)= a(k);
        fb=fm;
    else
        a(k+1)=Xm;
        b(k+1)=b(k);
        fa=fm;
    end
    Lk =(b(k)-a(k));
    k=k+1;  
    if (k>n)
        fprintf('numero de iteraciones superado\n');
        sol = (a(k-1)+b(k-1))/2.0;
        return;
    end
end
sol=Xm;
   